unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    bnStart: TButton;
    editor: TMemo;
    Button1: TButton;
    procedure bnStartClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Const NL = chr(13)+chr(10);

  function calcFibonacci1(n:integer):longint;
  var i:integer;
      a,b,c:longint;
  begin
    a:=1;
    b:=1;
    c:=0;
    for i:=3 to n do
    begin
      c := a + b;
      a := b;
      b := c;
    end;
    result := c;
  end;  

  function calcFibonacci2(n:integer):longint;
  var i:integer;
      a,b,c:longint;
  begin
     result := 0;
     if (n>0)
     then result := calcFibonacci2(n - 1) + calcFibonacci2(n - 2)
     else if (n = 1)
          then  result:=1
          else  result:=0;
  end;


procedure TForm1.bnStartClick(Sender: TObject);
var erg:longint;
    zahlen:array[0..10] of integer;
    t1,t2:longint;
    i:integer;
    n:longint;
begin
    zahlen[0] := 10;
    zahlen[1] := 20;
    zahlen[2] := 30;
    zahlen[3] := 35;
    zahlen[4] := 40;
    zahlen[5] := 45;
    zahlen[6] := 50;
    zahlen[7] := 55;
    zahlen[8] := 60;
    zahlen[9] := 70;
    zahlen[10] := 90;
    editor.Text := '';

    editor.Text := editor.Text +NL+'Test Fibonacci1 Iterativ';
    for i:=0 to 10 do
    begin
       n := zahlen[i];
       t1 := GetTickCount();
       erg:=calcFibonacci1(n);
       t2 := GetTickCount();
       editor.Text := editor.Text + NL+NL+'fib1: ' + IntToStr(n) + ' = ' + IntToStr(erg);
       editor.Text := editor.Text + NL+'  Zeit: ' + IntToStr(t2-t1);
       editor.Update();
    end;

    editor.Text := editor.Text + NL+NL+'Test Fibonacci2 Rekursiv';
    for i:=0 to 7 do
    begin
       n := zahlen[i];
       t1 := GetTickCount();
       erg:=calcFibonacci2(n);
       t2 := GetTickCount();
       editor.Text := editor.Text + NL+NL+'  fib2: ' + IntToStr(n) + ' = ' + IntToStr(erg);
       editor.Text := editor.Text + NL+'  Zeit: ' + IntToStr(t2-t1);
       editor.Update();
    end;
end;



procedure TForm1.Button1Click(Sender: TObject);
var erg:longint;
    zahlen:array[0..10] of integer;
    t1,t2:longint;
    i:integer;
    n:longint;
begin
    zahlen[0] := 10;
    zahlen[1] := 20;
    zahlen[2] := 30;
    zahlen[3] := 35;
    zahlen[4] := 40;
    zahlen[5] := 45;
    zahlen[6] := 50;
    zahlen[7] := 55;
    zahlen[8] := 60;
    zahlen[9] := 70;
    zahlen[10] := 90;
    editor.Text := '';

    editor.Text := editor.Text +NL+'Test Fibonacci1 Iterativ';
    for i:=0 to 10 do
    begin
       n := zahlen[i];
       t1 := GetTickCount();
       erg:=calcFibonacci1(n);
       t2 := GetTickCount();
       editor.Text := editor.Text + NL+NL+'fib1: ' + IntToStr(n) + ' = ' + IntToStr(erg);
       editor.Text := editor.Text + NL+'  Zeit: ' + IntToStr(t2-t1);
       editor.Update();
    end;

    editor.Text := editor.Text + NL+NL+'Test Fibonacci2 Rekursiv';
    for i:=8 to 10 do
    begin
       n := zahlen[i];
       t1 := GetTickCount();
       erg:=calcFibonacci2(n);
       t2 := GetTickCount();
       editor.Text := editor.Text + NL+NL+'  fib2: ' + IntToStr(n) + ' = ' + IntToStr(erg);
       editor.Text := editor.Text + NL+'  Zeit: ' + IntToStr(t2-t1);
       editor.Update();
    end;
end;

end.
