unit Start;


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, jpeg;


const C_ProgrammVersion1 = 'Version 2.00, Build 003';
const C_ProgrammVersion2 = ',  20. Dezember 2007';

type
  TFStart = class(TForm)
    Image1: TImage;
    LHead: TLabel;
    LWilhelm: TLabel;
    Timer1: TTimer;
    LVersion: TLabel;
    LFreeWare: TLabel;
    LWWW: TLabel;
    LEmail: TLabel;
    LDozent: TLabel;
    LCopyright: TLabel;
    LFBAI: TLabel;
    BnOk: TButton;
    procedure BnWeiterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Init;
    procedure LWWWClick(Sender: TObject);
    procedure LEmailClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BnOkClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FStart: TFStart;

implementation

{$R *.DFM}

uses basis;


procedure TFStart.FormCreate(Sender: TObject);
begin
  LVersion.Caption :=C_ProgrammVersion1+C_ProgrammVersion2;
  BnOk.left := (Clientwidth-BnOk.width) shr 1;
  LVersion.left := (Clientwidth-LVersion.width) shr 1;
end;

procedure TFStart.Init;
var w:integer;
begin
  Caption := 'Info zum Programm';
  Timer1.enabled := false;
  BnOk.visible := true;

  w := width;

  LHead.Left := (w-LHead.Width) shr 1;
  LFreeWare.Left := (w-LFreeWare.Width) shr 1;
  LVersion.Left := (w-LVersion.Width) shr 1;
  LCopyright.Left := (w-LCopyright.Width) shr 1;
  LWilhelm.Left := (w-LWilhelm.Width) shr 1;
  LDozent.Left := (w-LDozent.Width) shr 1;
  LFBAI.Left := (w-LFBAI.Width) shr 1;
  Lwww.Left := (w-Lwww.Width) shr 1;
  Lemail.Left := (w-Lemail.Width) shr 1;

  ShowModal;
end;

procedure TFStart.BnWeiterClick(Sender: TObject);
begin
  close;
end;


procedure TFStart.Timer1Timer(Sender: TObject);
begin
  Timer1.enabled := false;
  BnOk.visible := true;
end;


procedure TFStart.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := BnOk.visible;
end;





procedure TFStart.LWWWClick(Sender: TObject);
begin
  ExecuteFile('http://mwilhelm.hs-harz.de/','','', SW_SHOW);
end;

procedure TFStart.LEmailClick(Sender: TObject);
begin
  ExecuteFile('mailto:mwilhelm@hs-harz.de','','', SW_SHOW);
end;

procedure TFStart.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=13 then BnOkClick(Sender);
end;

procedure TFStart.BnOkClick(Sender: TObject);
begin
  close();

end;

end.

