//Titel:            Dialog-Fenster
//Version:
//Copyright:		Copyright (c) 2010
//Autor:
//Organisation:
//Beschreibung:


import java.awt.*;
import javax.swing.*;
import java.awt.event.*;


public class summen_thread_test2 extends JFrame {

  JButton BnTest1 = new JButton("Test1");
  JButton BnTest2 = new JButton("Test2");
  JButton BnTest3 = new JButton("Test3");
  JButton BnEsc = new JButton("Abbruch");


  private JTextArea memo;

  private long summe;


  public summen_thread_test2() {
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    setGUI();
  }

  private void setGUI() {
    setSize(480, 430);
    setTitle("JFrame als Dialog");

    BnTest1.setFont( new Font("Arial", Font.BOLD,18)  );
    BnTest2.setFont( new Font("Arial", Font.BOLD,18)  );
    BnTest3.setFont( new Font("Arial", Font.BOLD,18)  );
    BnEsc.setFont( new Font("Arial", Font.BOLD,18)  );
    BnTest1.setPreferredSize( BnEsc.getPreferredSize() );
    BnTest2.setPreferredSize( BnEsc.getPreferredSize() );
    BnTest3.setPreferredSize( BnEsc.getPreferredSize() );

    this.getContentPane().setLayout( new BorderLayout() );
    memo = new JTextArea();
    memo.setFont( new Font("Arial", Font.BOLD,24)  );
    this.getContentPane().add( new JScrollPane(memo), BorderLayout.CENTER);

	JPanel pnButton = new JPanel();
	//pnButton.setBackground(Color.red);
	pnButton.setLayout( new FlowLayout() );
	pnButton.add(BnTest1);
	pnButton.add(BnTest2);
	pnButton.add(BnTest3);
	pnButton.add(BnEsc);

    this.getContentPane().add( pnButton, BorderLayout.SOUTH );

          BnTest1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
              BnTest1_Click();
            }
          });
          BnTest2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
              BnTest2_Click();
            }
          });
          BnTest3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
              BnTest3_Click();
            }
          });


          BnEsc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
              BnEsc_Click();
            }
          });


  } // setGUI

    private void BnTest1_Click() {
      long t1, t2;
      summe=0;
      System.out.println("Test1");
      myThread[] ths = new myThread[10];
      for (int i=0; i<ths.length; i++) {
        ths[i] = new myThread(i+1,1000000);
      }
      t1 =  System.currentTimeMillis();
      for (int i=0; i<ths.length; i++) {
        ths[i].start();
      }
      try {
	      for (int i=0; i<ths.length; i++) {
    	    ths[i].join();
	      }
      }
      catch (InterruptedException e) {
      }
      t2 =  System.currentTimeMillis();
      memo.setText("Summe: "+Long.toString(summe)+"\n\r"+
            "Zeit: "+Long.toString(t2-t1) );
    }  // 65 3300

    private void BnTest2_Click() {
      long t1, t2;
		summe=0;
		long n = 1000000*10; 
      t1 =  System.currentTimeMillis();
		for (int i=1; i<=n; i++) {
         addNr(1); // _nr;
       }        //setVisible(false);
      t2 =  System.currentTimeMillis();
      memo.setText("Summe: "+Long.toString(summe)+"\n\r"+
            "Zeit: "+Long.toString(t2-t1) );
	 }
    
    private void BnTest3_Click() {
      long t1, t2;
      summe=0;
      System.out.println("Test1");
      myThread2[] ths = new myThread2[10];
      for (int i=0; i<ths.length; i++) {
        ths[i] = new myThread2(i+1,1000000);
      }
      t1 =  System.currentTimeMillis();
      for (int i=0; i<ths.length; i++) {
        ths[i].start();
      }
      try {
	      for (int i=0; i<ths.length; i++) {
    	    ths[i].join();
	      }
      }
      catch (InterruptedException e) {
      }
      t2 =  System.currentTimeMillis();
      memo.setText("Summe: "+Long.toString(summe)+"\n\r"+  "Zeit: "+Long.toString(t2-t1) );
    }  // Test3

	private void BnEsc_Click() {
      setVisible(false);
      System.exit(0);
    }

    private synchronized void addNr(int nr) {
     summe=summe+nr;
    }


  public static void main(String[] args) {
    summen_thread_test2 frame = new summen_thread_test2();
    frame.setVisible(true);
 }

   class myThread extends Thread {
     int _n;
     int _nr;
   
     public myThread (int nr, int n) {
        _n = n;
        _nr = nr;
     }
   
   
      // Thread Methode
     public void run() {
       for (int i=1; i<=_n; i++) {
         addNr(1); // _nr;
       }
     }
   
   
   }  // myThread


   class myThread2 extends Thread {
     int _n;
     int _nr;
   
     public myThread2 (int nr, int n) {
        _n = n;
        _nr = nr;
     }
   
   
      // Thread Methode
     public void run() {
		  int summe=0;
       for (int i=1; i<=_n; i++) {
         summe+=1; // _nr;
       }
       addNr(summe);
     }
   
   
   }  // myThread2

   
   

}  // summen_thread_test1






// synchronized
   /*
         try {
           Thread.sleep( (int) (Math.random()*150) );
         }
         catch (InterruptedException e) {
         }
   */
