﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LaGrange {
    public class Polynom {

        private int n = 15;

        public decimal[] coeff = null;
        private decimal[] coeff2 = null;

        private StringBuilder sb = new StringBuilder();


        public Polynom() {
            coeff = new decimal[n];
            for (int i=0; i<coeff.Length;i++) {
                coeff[i] = 0;
            }
            coeff2 = new decimal[n];
            for (int i = 0; i < coeff.Length; i++) {
                coeff2[i] = 0;
            }
        }

        public void Clear() {
            for (int i = 0; i < coeff.Length; i++) {
                coeff[i] = 0;
            }
        }

        public void setCoeff(int i, decimal value) {
            if (i>=0 && i< coeff.Length) {
                coeff[i] = value;
            }
            else {
                Basis.ErrorMsg("Fehlerhafter Index in Klasse Polynom, Index: " + i,"Fehler");
            }
        }

        public void mult(decimal coeff0) {
            for (int i = 0; i < coeff.Length; i++) {
                coeff2[i] = coeff[i];
            }

            // mult mit x
            for (int i=coeff.Length-2; i>=0; i--) {
                coeff[i + 1] = coeff[i];
            }
            coeff[0] = 0;
            for (int i = 0; i < coeff.Length; i++) {
                coeff[i] += coeff2[i]*coeff0;
            }
        }

        public void div(decimal value) {
            for (int i = 0; i < coeff.Length; i++) {
                coeff[i] /= value;
            }
        }
        public void multY(decimal value) {
            for (int i = 0; i < coeff.Length; i++) {
                coeff[i] *= value;
            }
        }

        public decimal Y(decimal x) {
            decimal y = 0.0m;
            for (int i = 0; i < coeff.Length; i++) {
                
                if (i==0) {
                    y += coeff[i];
                }
                else {
                    decimal xxx = 1;
                    for (int j=0; j<i; j++) {
                        xxx *= x;
                    }
                    y += coeff[i] * xxx;
                }
                
            }
            return y;
        }

        public override String ToString() {
            sb.Clear();
            bool nullValues = true;
            for (int i = coeff.Length-1; i >= 0; i--) {
                if (nullValues) {
                    if (coeff[i]!=0.0m) {
                        nullValues = false;
                    }
                }
                if (!nullValues) {
                    if (i==0) {
                        if (coeff[i]<0) {
                            sb.Append(" - ");
                            sb.Append((-coeff[i]).ToString("0.00000"));
                            sb.Append("    ");
                        }
                        else {
                            sb.Append(" + ");
                            sb.Append((coeff[i]).ToString("0.00000"));
                            sb.Append("    ");
                        }

                    }
                    else {
                        if (coeff[i] < 0) {
                            sb.Append(" - ");
                            sb.Append((-coeff[i]).ToString("0.00000"));
                        }
                        else {
                            sb.Append(" + ");
                            sb.Append((coeff[i]).ToString("0.00000"));
                        }
                        switch(i) {
                            case 1:
                                sb.Append("·x");
                                break;
                            case 2:
                                sb.Append("·x²");
                                break;
                            case 3:
                                sb.Append("·x³");
                                break;
                            default:
                                sb.Append("·x^");
                                sb.Append(i.ToString());
                                break;
                        }

                        
                        sb.Append("    ");
                    }
                }                
            }
            return sb.ToString();
        }

    }
}
