import java.io.*;
import java.util.Random;

public class MonteCarlo{


   private static void pause() {
    try {
      System.in.read();
    }
    catch (IOException e) {
    }
  }  // pause

   private static int getRandomNumberInRange(int min, int max) {
     if (min >= max) {
	throw new IllegalArgumentException("max must be greater than min");
    }
    Random r = new Random();
	return r.nextInt((max - min) + 1) + min;
   }


  public static void test1() {
   int n=100000;
  int innen=0;
 for (int i=0; i<n; i++) {
   int x1=getRandomNumberInRange(1,6);
   int x2=getRandomNumberInRange(1,6);
   if (x1<=(x2>>1)) {
    innen++;
   }
}
 
    System.out.println("innen: "+innen);
    System.out.println("n: "+n);
    System.out.println("Integral: "+(innen*1.0)/n*36);


    System.out.println("in test1");
  }

  public static void main(String[] args) {
    test1();
    pause();
  }
}
