
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

import java.math.BigDecimal;



public class bigdezimal2 extends JFrame {
   JLabel lErgebnis;
   JLabel lLoesung;
   JLabel lFormel;
   JToolBar toolBar;
   JButton BnBsp1, BnBsp2, BnBsp3;


  //Frame konstruieren
  public bigdezimal2() {
      setGUI();
      setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
  }

  private void setGUI() {
    JPanel panel = new JPanel();
    panel.setLayout( new FlowLayout() );
    setSize(900, 320);
    this.setLocation(100, 100);
    this.setTitle("Beispiel bigdezimal2");

    toolBar = new JToolBar();
    this.getContentPane().add(toolBar, BorderLayout.NORTH);

    BnBsp1 = new JButton( "Single" );
    BnBsp1.setFont( new Font("Arial", Font.BOLD,32));
    BnBsp1.addActionListener(new java.awt.event.ActionListener() {
       public void actionPerformed(ActionEvent e) {
        BnBsp1_Click();
       }
    });
    toolBar.add(BnBsp1);

    BnBsp2 = new JButton( "Double" );
    BnBsp2.setFont( new Font("Arial", Font.BOLD,32));
    BnBsp2.addActionListener(new java.awt.event.ActionListener() {
       public void actionPerformed(ActionEvent e) {
        BnBsp2_Click();
       }
    });
    toolBar.add(BnBsp2);

    BnBsp3 = new JButton( "Big" );
    BnBsp3.setFont( new Font("Arial", Font.BOLD,32));
    BnBsp3.addActionListener(new java.awt.event.ActionListener() {
       public void actionPerformed(ActionEvent e) {
        BnBsp3_Click();
       }
    });
    toolBar.add(BnBsp3);

    JPanel panelMitte = new JPanel();
    panelMitte.setLayout( new GridLayout(3,1));
    lFormel = new JLabel("-");
    lFormel.setFont( new Font("Arial", Font.BOLD,32));
   lLoesung = new JLabel("-");
    lLoesung.setFont( new Font("Arial", Font.BOLD,32));
    lErgebnis = new JLabel("-");
    lErgebnis.setFont( new Font("Arial", Font.BOLD,32));

    panelMitte.add(lFormel);
    panelMitte.add(lLoesung);
    panelMitte.add(lErgebnis);
    this.getContentPane().add(panelMitte, BorderLayout.CENTER);
  }

  void   BnBsp1_Click() {
     float p, x, y;
     x = 10864.0f;
     y = 18817.0f;
     p = (float) 9.0*x*x*x*x -y*y*y*y +2*y*y;
     lErgebnis.setText("Ergebnis: "+Float.toString(p)+"  (Single)");
     lLoesung.setText("Lsung: 1.0");
     lFormel.setText("9.0*x*x*x*x -y*y*y*y +2*y*y  x = 10864; y = 18817; ");
  }

  void   BnBsp2_Click() {
     double p, x, y;
     x = 10864.0;
     y = 18817.0;
     p = 9.0*x*x*x*x -y*y*y*y +2*y*y;
     lErgebnis.setText("Ergebnis: "+Double.toString(p)+"  (Double)");
     lLoesung.setText("Lsung: 1.0");
     lFormel.setText("9.0*x*x*x*x -y*y*y*y +2*y*y     x = 10864; y = 18817; ");
  }

  void   BnBsp3_Click() {
     BigDecimal p, p1, p2, p3, x, y, x4, y4;

     x = new BigDecimal("10864.0");
     y = new BigDecimal("18817.0");

     x4 = x.multiply(x);
     x4 = x4.multiply(x4);  // x^4

     y4 = y.multiply(y);    // Y^2
     p2 = y4.multiply(y4);  // y^4

     p1 = x4.multiply( new BigDecimal("9.0") );

     p3 = y.multiply(y);
     p3 = p3.multiply( new BigDecimal("2.0") );

     p = p1.subtract(p2);
     p = p.add(p3);
     lErgebnis.setText("Ergebnis: "+  p.toString()+"  (Big)");
     lLoesung.setText("Lsung: 1.0");
     lFormel.setText("9.0*x*x*x*x -y*y*y*y +2*y*y     x = 10864; y = 18817; ");
  }

  public static void main(String[] args) {
    bigdezimal2 frame = new bigdezimal2();
    frame.setVisible(true);
  }


}
