
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

import java.math.BigDecimal;



public class bigdezimal3 extends JFrame {
   JLabel lErgebnis;
   JLabel lFormel1;
   JLabel lFormel2;
   JLabel lFormel3;
   JToolBar toolBar;
   JButton BnBsp1, BnBsp2, BnBsp3;


  //Frame konstruieren
  public bigdezimal3() {
       setGUI();
      setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
  }

  private void setGUI() {
    JPanel panel = new JPanel();
    panel.setLayout( new FlowLayout() );
    setSize(900, 320);
    this.setLocation(100, 100);
    this.setTitle("Beispiel bigdezimal3");

    this.getContentPane().setLayout( new GridLayout(5,1) );
    toolBar = new JToolBar();
    this.getContentPane().add(toolBar, BorderLayout.NORTH);

    BnBsp1 = new JButton( "Single" );
    BnBsp1.setFont( new Font("Arial", Font.BOLD,32));
    BnBsp1.addActionListener(new java.awt.event.ActionListener() {
       public void actionPerformed(ActionEvent e) {
        BnBsp1_Click();
       }
    });
    toolBar.add(BnBsp1);

    BnBsp2 = new JButton( "Double" );
    BnBsp2.setFont( new Font("Arial", Font.BOLD,32));
    BnBsp2.addActionListener(new java.awt.event.ActionListener() {
       public void actionPerformed(ActionEvent e) {
        BnBsp2_Click();
       }
    });
    toolBar.add(BnBsp2);

    BnBsp3 = new JButton( "Big" );
    BnBsp3.setFont( new Font("Arial", Font.BOLD,32));
    BnBsp3.addActionListener(new java.awt.event.ActionListener() {
       public void actionPerformed(ActionEvent e) {
        BnBsp3_Click();
       }
    });
    toolBar.add(BnBsp3);

    lFormel1 = new JLabel("-");
    lFormel1.setFont( new Font("Arial", Font.BOLD,32) );
    this.getContentPane().add(lFormel1);

    lFormel2 = new JLabel("-");
    lFormel2.setFont( new Font("Arial", Font.BOLD,32) );
    this.getContentPane().add(lFormel2);

    lFormel3 = new JLabel("-");
    lFormel3.setFont( new Font("Arial", Font.BOLD,32) );
    this.getContentPane().add(lFormel3);


    lErgebnis = new JLabel("-");
    lErgebnis.setFont( new Font("Arial", Font.BOLD,32) );
    this.getContentPane().add(lErgebnis);
  }

  void   BnBsp1_Click() {
     float p, x, y;
     x = 9478657.0f;
     y = 2298912.0f;

     p = (float ) 83521.0f*y*y*y*y*y*y*y*y +578.0f*x*x*y*y*y*y
               -2.0f*x*x*x*x + 2.0f*x*x*x*x*x*x -x*x*x*x*x*x*x*x;
     lErgebnis.setText("Ergebnis: "+Float.toString(p)+"  (Single)");
     lFormel1.setText("83521y^8 +578x^2y^4 -2x^4 + 2x^6 -x^8");
     lFormel2.setText("x = 9478657; y = 2298912; ");
     lFormel3.setText("Lsung:  -179 689 877 047 297");
  }


  void   BnBsp2_Click() {
     double p, x, y, x4, y4, x2;
     x = 9478657.0;
     y = 2298912.0;

     y4 = y*y*y*y;
     x2 = x*x;
     x4 = x2*x2;
     p = 83521.0*y4*y4 +578.0*x2*y4  -2.0*x4 + 2.0*x2*x4 -x4*x4;
     lErgebnis.setText("Ergebnis: "+Double.toString(p)+"  (Double)");
     lFormel1.setText("83521y^8 +578x^2y^4 -2x^4 + 2x^6 -x^8");
     lFormel2.setText("x = 9478657; y = 2298912; ");
     lFormel3.setText("Lsung:  -179 689 877 047 297");
  }

  void   BnBsp3_Click() {
     BigDecimal p, p1, p2, p3, p4, p5, x, y, x2, x4, y4, y8;
     BigDecimal c1, c2, c3;

     c1 =new BigDecimal("83521.0");
     c2 =new BigDecimal("578.0");
     c3 =new BigDecimal("2.0");

     x = new BigDecimal("9478657.0");
     y = new BigDecimal("2298912.0");

     x2 = x.multiply(x);
     x4 = x2.multiply(x2);  // x^4

     y4 = y.multiply(y);  // y^2
     y4 = y4.multiply(y4);  // y^4
     y8 = y4.multiply(y4);  // y^8

     // "83521y^8 +578x^2y^4   -2x^4 + 2x^6 -x^8");
     //      p1      p2          p3      p4   p5
     p1 = c1.multiply( y8 );

     p2 = c2.multiply( x2 );
     p2 = p2.multiply( y4 );

     p3 = c3.multiply( x4 );

     p4 = c3.multiply( x4 );
     p4 = p4.multiply( x2 );

     p5 = x4.multiply(x4);

     p = p1.add(p2);
     p = p.subtract(p3);
     p = p.add(p4);
     p = p.subtract(p5);

     lErgebnis.setText("Ergebnis: "+p.toString()+"  (Big)");
     lFormel1.setText("83521y^8 +578x^2y^4 -2x^4 + 2x^6 -x^8");
     lFormel2.setText("x = 9478657; y = 2298912; ");
     lFormel3.setText("Lsung:  -179 689 877 047 297");
  }


  public static void main(String[] args) {
    bigdezimal3 frame = new bigdezimal3();
    frame.setVisible(true);
  }


}
